lens-action-0.2.3: Monadic Getters and Folds

Copyright | (C) 2012-14 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe
Language | Haskell98

Control.Lens.Action.Reified

Description

Synopsis

- newtype ReifiedMonadicFold m s a = MonadicFold {
  - runMonadicFold :: MonadicFold m s a
  }

# Documentation

newtype ReifiedMonadicFold m s a Source #

Reify a `ReifiedMonadicFold` so it can be stored safely in a container.

Constructors

MonadicFold |

Fields

- runMonadicFold :: MonadicFold m s a

Instances

MonadReader s (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods ask :: ReifiedMonadicFold m s s Source # local :: (s -> s) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # reader :: (s -> a) -> ReifiedMonadicFold m s a Source #
Arrow (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

arr :: (b -> c) -> ReifiedMonadicFold m b c Source #

first :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (b, d) (c, d) Source #

second :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (d, b) (d, c) Source #

(***) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b' c' -> ReifiedMonadicFold m (b, b') (c, c') Source #

(&&&) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b c' -> ReifiedMonadicFold m b (c, c') Source #

ArrowChoice (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

left :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (Either b d) (Either c d) Source #

right :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (Either d b) (Either d c) Source #

(+++) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b' c' -> ReifiedMonadicFold m (Either b b') (Either c c') Source #

(|||) :: ReifiedMonadicFold m b d -> ReifiedMonadicFold m c d -> ReifiedMonadicFold m (Either b c) d Source #

ArrowApply (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods app :: ReifiedMonadicFold m (ReifiedMonadicFold m b c, b) c Source #
Profunctor (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

dimap :: (a -> b) -> (c -> d) -> ReifiedMonadicFold m b c -> ReifiedMonadicFold m a d Source #

lmap :: (a -> b) -> ReifiedMonadicFold m b c -> ReifiedMonadicFold m a c Source #

rmap :: (b -> c) -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c Source #

(#.) :: Coercible c b => q b c -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c Source #

(.#) :: Coercible b a => ReifiedMonadicFold m b c -> q a b -> ReifiedMonadicFold m a c Source #

Choice (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods left' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (Either a c) (Either b c) Source # right' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (Either c a) (Either c b) Source #
Strong (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods first' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (a, c) (b, c) Source # second' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (c, a) (c, b) Source #
Category (ReifiedMonadicFold m :: Type -> Type -> Type) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods id :: ReifiedMonadicFold m a a Source # (.) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c Source #
Monad (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (>>=) :: ReifiedMonadicFold m s a -> (a -> ReifiedMonadicFold m s b) -> ReifiedMonadicFold m s b Source # (>>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b Source # return :: a -> ReifiedMonadicFold m s a Source # fail :: String -> ReifiedMonadicFold m s a Source #
Functor (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods fmap :: (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b Source # (<$) :: a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a Source #
Applicative (ReifiedMonadicFold m s) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

pure :: a -> ReifiedMonadicFold m s a Source #

(<*>) :: ReifiedMonadicFold m s (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b Source #

liftA2 :: (a -> b -> c) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s c Source #

(*>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b Source #

(<*) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a Source #

Alternative (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods empty :: ReifiedMonadicFold m s a Source # (<|>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # some :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source # many :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source #
MonadPlus (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods mzero :: ReifiedMonadicFold m s a Source # mplus :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source #
Apply (ReifiedMonadicFold m s) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

(<.>) :: ReifiedMonadicFold m s (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b Source #

(.>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b Source #

(<.) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a Source #

liftF2 :: (a -> b -> c) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s c Source #

Plus (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods zero :: ReifiedMonadicFold m s a Source #
Alt (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (<!>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # some :: Applicative (ReifiedMonadicFold m s) => ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source # many :: Applicative (ReifiedMonadicFold m s) => ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source #
Bind (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (>>-) :: ReifiedMonadicFold m s a -> (a -> ReifiedMonadicFold m s b) -> ReifiedMonadicFold m s b Source # join :: ReifiedMonadicFold m s (ReifiedMonadicFold m s a) -> ReifiedMonadicFold m s a Source #
Semigroup (ReifiedMonadicFold m s a) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (<>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # sconcat :: NonEmpty (ReifiedMonadicFold m s a) -> ReifiedMonadicFold m s a Source # stimes :: Integral b => b -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source #
Monoid (ReifiedMonadicFold m s a) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods mempty :: ReifiedMonadicFold m s a Source # mappend :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # mconcat :: [ReifiedMonadicFold m s a] -> ReifiedMonadicFold m s a Source #